﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Encodings.PermutationEncoding;
using HeuristicLab.Problems.VehicleRouting.Interfaces;

namespace HeuristicLab.Operators.MPISupport.BinaryTransport {
  class ItemTransfer {
    public static object Convert(IItem item) {
      if (item is IScope)
        return ScopeTransfer.Convert(item as IScope);
      else if (item is IVariable)
        return VariableTransfer.Convert(item as IVariable);
      else if (item is DoubleValue)
        return DoubleValueTransfer.Convert(item as DoubleValue);
      else if (item is IntValue)
        return IntValueTransfer.Convert(item as IntValue);
      else if (item is IVRPEncoding)
        return VRPTransfer.Convert(item as IVRPEncoding);
      else if (item is Permutation)
        return PermutationTransfer.Convert(item as Permutation);
      else
        return null;
    }

    public static IItem Convert(object item, IExecutionContext globalScope) {
      if (item is ScopeTransfer)
        return ScopeTransfer.Convert(item as ScopeTransfer, globalScope);
      else if (item is VariableTransfer)
        return VariableTransfer.Convert(item as VariableTransfer, globalScope);
      else if (item is DoubleValueTransfer)
        return DoubleValueTransfer.Convert(item as DoubleValueTransfer);
      else if (item is IntValueTransfer)
        return IntValueTransfer.Convert(item as IntValueTransfer);
      else if (item is PermutationTransfer)
        return PermutationTransfer.Convert(item as PermutationTransfer);
      else if (item is VRPTransfer)
        return VRPTransfer.Convert(item as VRPTransfer, globalScope);
      else
        return null;
    }
  }
}
